"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Sensor = void 0;
var utils_1 = require("../utils");
var Sensor = /** @class */ (function () {
    function Sensor(devAddr, mcuId) {
        this.devAddr = undefined;
        this.mcuId = undefined;
        this.lastValue = 0.0;
        if (devAddr)
            this.devAddr = devAddr;
        if (mcuId)
            this.mcuId = mcuId;
    }
    Sensor.prototype.getValueBasedOnPrevious = function (max, interval, round) {
        if (round === void 0) { round = true; }
        return (0, utils_1.randomNumberInRange)(this.lastValue ? this.lastValue - interval : this.lastValue, this.lastValue ? this.lastValue + interval : max, round);
    };
    Sensor.prototype.setDevAddr = function (devAddr) {
        this.devAddr = devAddr;
    };
    Sensor.prototype.setMcuId = function (mcuId) {
        this.mcuId = mcuId;
    };
    Sensor.prototype.getDevAddr = function () {
        return this.devAddr;
    };
    Sensor.prototype.getMcuId = function () {
        return this.mcuId;
    };
    return Sensor;
}());
exports.Sensor = Sensor;
